TextView = luajava.bindClass("android.widget.TextView")
EditText = luajava.bindClass("android.widget.EditText")
Button = luajava.bindClass("android.widget.Button")
LinearLayout = luajava.bindClass("android.widget.LinearLayout")
Gravity = luajava.bindClass("android.view.Gravity")

function splitUTF8(text)
  local chars = {}
  for uchar in text:gmatch("[%z\1-\127\194-\244][\128-\191]*") do
    table.insert(chars, uchar)
  end
  return chars
end

function reverseWord(word)
  local chars = splitUTF8(word)
  local reversed = ""
  for i = #chars, 1, -1 do
    reversed = reversed .. chars[i]
  end
  return reversed
end

function reverseEachWord(text)
  local result = ""
  for word in text:gmatch("%S+") do
    result = result .. reverseWord(word) .. " "
  end
  return result:sub(1, -2)
end

layout = LinearLayout(activity)
layout.setOrientation(1)
layout.setPadding(16, 16, 16, 16)
layout.setGravity(Gravity.CENTER)

title = TextView(activity)
title.setText("اكتب رسالتك")
title.setTextSize(18)
layout.addView(title)

input = EditText(activity)
input.setHint("مثال: حسن تصوير")
layout.addView(input)

button = Button(activity)
button.setText("اعكس الأحرف في كل كلمة")
layout.addView(button)

result = TextView(activity)
result.setTextSize(16)
result.setTextColor(0xFF444444)
layout.addView(result)

button.setOnClickListener(luajava.createProxy("android.view.View$OnClickListener", {
  onClick = function(v)
    local msg = input.getText().toString()
    result.setText(reverseEachWord(msg))
  end
}))

activity.setContentView(layout)